#include "spi_flash_misc.h"

#define NRF_LOG_MODULE_NAME spi_flash_misc
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
NRF_LOG_MODULE_REGISTER();

#include <stddef.h>
#include <stdint.h>
#include "sdk_config.h"
#include "crc32.h"



static uint32_t m_dat_addr = APP_CFG_INIT_START_ADDR; // bprumo NOTE: this is the address in SPI with the Header
static uint32_t m_bin_addr = APP_CFG_FW_START_ADDR;   // bprumo NOTE: this is the address in SPI with the image. Hard-coding to an offset of 1 page in for now, but this should be read from the Header in the future.


uint32_t spi_flash_get_fw_dat_addr(void)
{
    return m_dat_addr;
}

uint32_t spi_flash_get_fw_bin_addr(void)
{
    return m_bin_addr;
}

uint32_t spi_flash_verify_init(const spi_flash_init_cmd_t *p_init)
{
    uint32_t err_code;
    uint32_t crc32;

    crc32 = crc32_compute((uint8_t const *) p_init, offsetof(spi_flash_init_cmd_t, cmd_crc), NULL);

    err_code = (p_init->app_size > 0 && p_init->cmd_crc == crc32) ? 
               NRF_SUCCESS : 
               NRF_ERROR_INVALID_DATA;

    return err_code;
}
